=== modified file 'lib/lp/bugs/javascript/buglisting.js'
--- lib/lp/bugs/javascript/buglisting.js	2011-11-25 23:39:37 +0000
+++ lib/lp/bugs/javascript/buglisting.js	2011-11-28 20:51:15 +0000
@@ -19,77 +19,6 @@
 
 /**
  * Constructor.
- *
- * This is the model of the current batch, including the ordering, position,
- * and what fields are visibile.
- *
- * These values are stored in the History object, so that the browser
- * back/next buttons correctly adjust.  The system defaults for field
- * visibility are fixed, so they are stored directly on the object.
- *
- * Accepts a config containing:
- *  - field_visibility the requested field visibility as an associative array
- *  - field_visibility_defaults the system defaults for field visibility as an
- *    associative array.
- *  - batch_key: A string representing the position and ordering of the
- *    current batch, as returned by ListingNavigator.get_batch_key
- */
-namespace.BugListingModel = function(){
-    namespace.BugListingModel.superclass.constructor.apply(this, arguments);
-};
-
-
-namespace.BugListingModel.NAME = 'buglisting-model';
-
-
-namespace.BugListingModel.ATTRS = {
-    field_visibility_defaults: {
-        value: null
-    }
-};
-
-
-Y.extend(namespace.BugListingModel, Y.Base, {
-    /**
-     * Initializer sets up the History object that stores most of the model
-     * data.
-     */
-    initializer: function(config){
-        this.set('history', new Y.History({
-            initialState: Y.merge(
-                config.field_visibility, {batch_key: config.batch_key})
-        }));
-    },
-
-    /**
-     * Return the current field visibility, as an associative array.
-     * Since the history contains field values that are not field-visibility,
-     * use field_visibility_defaults to filter out non-field-visibility
-     * values.
-     */
-    get_field_visibility: function(){
-        var result = this.get('history').get();
-        var key_source = this.get('field_visibility_defaults');
-        Y.each(result, function(value, key){
-            if (!key_source.hasOwnProperty(key)){
-                delete result[key];
-            }
-        });
-        return result;
-    },
-
-    /**
-     * Set the field visibility, updating history.  Accepts an associative
-     * array.
-     */
-    set_field_visibility: function(value){
-        this.get('history').add(value);
-    }
-});
-
-
-/**
- * Constructor.
  * current_url is used to determine search params.
  * cache is the JSONRequestCache for the batch.
  * template is the template to use for rendering batches.
@@ -116,6 +45,7 @@
     spinners: {valueFn: empty_nodelist}
 };
 
+
 Y.extend(namespace.ListingNavigator, Y.Base, {
     initializer: function(config) {
         var lp_client = new Y.lp.client.Launchpad();
@@ -128,12 +58,9 @@
         delete this.get('search_params').direction;
         delete this.get('search_params').orderby;
         this.set('io_provider', config.io_provider);
+        this.set('field_visibility', cache.field_visibility);
         batch_key = this.handle_new_batch(cache);
-        this.set('model', new namespace.BugListingModel({
-                batch_key: batch_key,
-                field_visibility: cache.field_visibility,
-                field_visibility_defaults: cache.field_visibility_defaults
-        }));
+        this.set('current_batch', cache);
         this.pre_fetch_batches();
         // Work around mustache.js bug 48 "Blank lines are not preserved."
         // https://github.com/janl/mustache.js/issues/48
@@ -146,8 +73,12 @@
         if (Y.Lang.isValue(config.navigation_indices)) {
             this.set('navigation_indices', config.navigation_indices);
         }
-        this.get('model').get('history').after(
-            'change', this.history_changed, this);
+        this.set('history', new Y.History({
+            initialState: {
+                batch_key: batch_key
+            }
+        }));
+        this.get('history').on('change', this.history_changed, this);
     },
 
     get_failure_handler: function(fetch_only){
@@ -168,6 +99,7 @@
         if (e.newVal.hasOwnProperty('batch_key')) {
             var batch_key = e.newVal.batch_key;
             var batch = this.get('batches')[batch_key];
+            this.set('current_batch', batch);
             this.pre_fetch_batches();
             this.render();
         }
@@ -188,14 +120,6 @@
     },
 
     /**
-     * Retrieve the current batch for rendering purposes.
-     */
-    get_current_batch: function(){
-        var batch_key = this.get('model').get('history').get('batch_key');
-        return this.get('batches')[batch_key];
-    },
-
-    /**
      * Handle a previously-unseen batch by storing it in the cache and
      * stripping out field_visibility values that would otherwise shadow the
      * real values.
@@ -203,7 +127,7 @@
      handle_new_batch: function(batch) {
         var key, i;
         var batch_key = this.constructor.get_batch_key(batch);
-        Y.each(batch.field_visibility, function(value, key) {
+        Y.each(this.get('field_visibility'), function(value, key) {
             for (i = 0; i < batch.mustache_model.bugtasks.length; i++) {
                 delete batch.mustache_model.bugtasks[i][key];
             }
@@ -221,15 +145,14 @@
      * The template is always LP.mustache_listings.
      */
     render: function() {
-        var current_batch = this.get_current_batch();
         var model = Y.merge(
-            current_batch.mustache_model,
-            this.get('model').get_field_visibility());
+            this.get('current_batch').mustache_model,
+            this.get('field_visibility'));
         var batch_info = Mustache.to_html(this.get('batch_info_template'), {
-            start: current_batch.start + 1,
-            end: current_batch.start +
-                current_batch.mustache_model.bugtasks.length,
-            total: current_batch.total
+            start: this.get('current_batch').start + 1,
+            end: this.get('current_batch').start +
+                this.get('current_batch').mustache_model.bugtasks.length,
+            total: this.get('current_batch').total
         });
         var content = Mustache.to_html(this.get('template'), model);
         this.get('target').setContent(content);
@@ -247,11 +170,11 @@
     },
 
     has_prev: function(){
-        return !Y.Lang.isNull(this.get_current_batch().prev);
+        return !Y.Lang.isNull(this.get('current_batch').prev);
     },
 
     has_next: function(){
-        return !Y.Lang.isNull(this.get_current_batch().next);
+        return !Y.Lang.isNull(this.get('current_batch').next);
     },
 
     /**
@@ -282,8 +205,7 @@
      */
     update_from_cache: function(query, batch_key) {
         var url = '?' + Y.QueryString.stringify(query);
-        this.get('model').get('history').addValue(
-            'batch_key', batch_key, {url: url});
+        this.get('history').addValue('batch_key', batch_key, {url: url});
     },
 
     /**
@@ -346,18 +268,17 @@
      * Update the navigator to display the last batch.
      */
     last_batch: function() {
-        var current_batch = this.get_current_batch();
         this.update({
             forwards: false,
             memo: "",
-            start: current_batch.last_start,
-            order_by: current_batch.order_by
+            start: this.get('current_batch').last_start,
+            order_by: this.get('current_batch').order_by
         });
     },
 
     first_batch_config: function(order_by){
         if (order_by === undefined) {
-            order_by = this.get_current_batch().order_by;
+            order_by = this.get('current_batch').order_by;
         }
         return {
             forwards: true,
@@ -377,7 +298,7 @@
     },
 
     next_batch_config: function(){
-        var current_batch = this.get_current_batch();
+        var current_batch = this.get('current_batch');
         if (!this.has_next()){
             return null;
         }
@@ -399,7 +320,7 @@
         this.update(config);
     },
     prev_batch_config: function(){
-        var current_batch = this.get_current_batch();
+        var current_batch = this.get('current_batch');
         if (!this.has_prev()){
             return null;
         }
@@ -421,6 +342,16 @@
         this.update(config);
     },
     /**
+     * Change which fields are displayed in the batch.  Input is a config with
+     * the appropriate visibility variables, such as show_bug_heat,
+     * show_title, etc.
+     */
+    change_fields: function(config) {
+        this.set('field_visibility', Y.merge(this.field_visibility, config));
+        this.render();
+    },
+
+    /**
      * Generate a list of configs to pre-fetch.
      */
     get_pre_fetch_configs: function(){
@@ -446,7 +377,7 @@
                 failure: this.get_failure_handler(fetch_only)
             }
         };
-        var context = this.get_current_batch().context;
+        var context = this.get('current_batch').context;
         if (Y.Lang.isValue(this.get('io_provider'))) {
             load_model_config.io_provider = this.get('io_provider');
         }

=== modified file 'lib/lp/bugs/javascript/buglisting_utils.js'
--- lib/lp/bugs/javascript/buglisting_utils.js	2011-11-25 21:16:04 +0000
+++ lib/lp/bugs/javascript/buglisting_utils.js	2011-11-28 20:51:15 +0000
@@ -2,7 +2,7 @@
 
 YUI().add('lp.buglisting_utils', function(Y) {
     /**
-     * A utility for configuring the display of bug listings.
+     * A utiltiy for configuring the display of bug listings.
      *
      * The purpose of this widget is be a mechanism for turning
      * fields on and off in a bug listing display.  It extends
@@ -18,22 +18,13 @@
      */
 
     // Constants.
-    var FORM = 'form';
-
+    var FORM = 'form',
+        FIELD_VISIBILITY = 'field_visibility';
 
     /**
      * BugListingConfigUtil is the main object used to manipulate
      * a bug listing's display.
      *
-     * Constructor accepts a config containing
-     * - model (a BugListingModel)
-     * - cookie_name
-     * - form the FormOverlay to manipulate
-     *
-     * If model is not supplied, model parameters must be included, especially
-     * - form_visibility
-     * - form_visibility_defaults
-     *
      * @class BugListingConfigUtil
      * @extends Y.lp.configutils.BaseConfigUtil
      * @constructor
@@ -65,6 +56,51 @@
     BugListingConfigUtil.ATTRS = {
 
         /**
+         * A config for field visibility.  This determines which
+         * fields are visibile in a bug listing.
+         *
+         * @attribute field_visibility
+         * @type Object
+         */
+        field_visibility: {
+            valueFn: function() {
+                return this.get('field_visibility_defaults');
+            },
+            setter: function(value) {
+                var defaults = this.get('field_visibility_defaults');
+                return Y.merge(defaults, value);
+            }
+        },
+
+        /**
+         * Defaults from field_visibility which are taken from LP.cache.
+         *
+         * This utility will error if LP.cache doesn't exist or doesn't
+         * have field_visibility defined.
+         *
+         * @attribute field_visibility_defaults
+         * @type Object
+         * @default null
+         * @readOnly
+         */
+        field_visibility_defaults: {
+            valueFn: function() {
+                if (
+                    Y.Lang.isValue(window.LP) &&
+                    Y.Lang.isValue(LP.cache.field_visibility_defaults)) {
+                    return LP.cache.field_visibility_defaults;
+                } else {
+                    var msg = [
+                        'LP.cache.field_visibility must be defined ',
+                        'when using BugListingConfigUtil.'
+                    ].join('');
+                    Y.error(msg);
+                }
+            },
+            readOnly: true
+        },
+
+        /**
          * The cookie name as set by the view.
          *
          * We get this value from the LP cache.
@@ -93,9 +129,6 @@
          */
         form: {
             value: null
-        },
-        model: {
-            value: null
         }
     };
 
@@ -105,16 +138,6 @@
 
     Y.extend(BugListingConfigUtil, Y.lp.configutils.BaseConfigUtil, {
 
-        initializer: function(config){
-            if (config === undefined){
-                config = {};
-            }
-            if (Y.Lang.isNull(this.get('model'))){
-                this.set('model',
-                    new Y.lp.bugs.buglisting.BugListingModel(config));
-            }
-        },
-
         /**
          * Hook into the destroy lifecyle to ensure the form
          * overlay is destroyed.
@@ -135,7 +158,7 @@
          * @method getFormInputs
          */
         getFormInputs: function() {
-            var fields = this.get('model').get_field_visibility();
+            var fields = this.get(FIELD_VISIBILITY);
             var display_names = this.constructor.field_display_names;
             var nodes = [];
             var item,
@@ -177,8 +200,7 @@
             link.addClass('reset-buglisting');
             link.setContent('Reset to default');
             link.on('click', function(e) {
-                var model = this.get('model');
-                var defaults = model.get('field_visibility_defaults');
+                var defaults = this.get('field_visibility_defaults');
                 this.updateFieldVisibilty(defaults, true);
                 this.setCookie();
             }, this);
@@ -201,12 +223,29 @@
         },
 
         /**
+         * Hook up the global events we want to fire.
+         *
+         * We do these as a global event rather than listening for
+         * attribute change events to avoid having to have a reference
+         * to the widget in another widget.
+         *
+         * @method addListeners
+         */
+        addListeners: function() {
+            // Fire a buglisting-config-util:fields-changed event.
+            this.after('field_visibilityChange', function() {
+                var event_name = this.constructor.NAME + ':fields-changed';
+                Y.fire(event_name);
+            });
+        },
+
+        /**
          * Helper method for updating field_visibility.
          *
          * @method updateFieldVisibilty
          */
         updateFieldVisibilty: function(fields, destroy_form) {
-            this.get('model').set_field_visibility(fields);
+            this.set(FIELD_VISIBILITY, fields);
             var form = this.get(FORM);
             if (Y.Lang.isValue(form)) {
                 form.hide();
@@ -229,7 +268,7 @@
          * @method handleOverlaySubmit
          */
         handleOverlaySubmit: function(data) {
-            var fields = this.get('model').get_field_visibility();
+            var fields = this.get('field_visibility_defaults');
             var member;
             for (member in fields) {
                 if (fields.hasOwnProperty(member)) {
@@ -318,6 +357,7 @@
             util_overlay.get(
                 'boundingBox').addClass(this.getClassName('overlay'));
             this.set(FORM, util_overlay);
+            this.addListeners();
             util_overlay.render();
             util_overlay.hide();
         },
@@ -338,7 +378,4 @@
     var buglisting_utils = Y.namespace('lp.buglisting_utils');
     buglisting_utils.BugListingConfigUtil = BugListingConfigUtil;
 
-}, '0.1', {'requires': [
-    'cookie', 'history', 'lp.configutils', 'lazr.formoverlay',
-    'lp.bugs.buglisting'
-    ]});
+}, '0.1', {'requires': ['cookie', 'lp.configutils', 'lazr.formoverlay']});

=== modified file 'lib/lp/bugs/javascript/tests/test_buglisting.js'
--- lib/lp/bugs/javascript/tests/test_buglisting.js	2011-11-25 23:39:37 +0000
+++ lib/lp/bugs/javascript/tests/test_buglisting.js	2011-11-28 20:51:15 +0000
@@ -31,7 +31,7 @@
                 prev: null
             }
         });
-        bugtask = navigator.get_current_batch().mustache_model.bugtasks[0];
+        bugtask = navigator.get('current_batch').mustache_model.bugtasks[0];
         Y.Assert.isFalse(bugtask.hasOwnProperty('show_item'));
     },
     test_cleans_visibility_from_new_batch: function() {
@@ -39,12 +39,11 @@
         var bugtask;
         var target = Y.Node.create('<div id="client-listing"></div>');
         var model = {
+            field_visibility: {show_item: true},
             mustache_model: {bugtasks: []},
             memo: 1,
             next: null,
-            prev: null,
-            field_visibility: {},
-            field_visibility_defaults: {show_item: true}
+            prev: null
         };
         var navigator = new module.ListingNavigator({
             current_url: '',
@@ -57,12 +56,11 @@
                 bugtasks: [{show_item: true}]},
             memo: 2,
             next: null,
-            prev: null,
-            field_visibility: {show_item: true}
+            prev: null
         };
         var query = navigator.get_batch_query(batch);
         navigator.update_from_new_model(query, false, batch);
-        bugtask = navigator.get_current_batch().mustache_model.bugtasks[0];
+        bugtask = navigator.get('current_batch').mustache_model.bugtasks[0];
         Y.Assert.isFalse(bugtask.hasOwnProperty('show_item'));
     }
 }));
@@ -84,8 +82,7 @@
             prev: null,
             start: 5,
             total: 256,
-            field_visibility: {show_foo: true},
-            field_visibility_defaults: {show_foo: false}
+            field_visibility: {show_foo: true}
         };
         var template = "{{#bugtasks}}{{#show_foo}}{{foo}}{{/show_foo}}" +
             "{{/bugtasks}}";
@@ -130,7 +127,7 @@
         var navigator = this.get_render_navigator();
         var action = navigator.get('backwards_navigation').item(0);
         action.addClass('inactive');
-        navigator.get_current_batch().prev = {
+        navigator.get('current_batch').prev = {
             start: 1, memo: 'pi'
         };
         navigator.render_navigation();
@@ -155,7 +152,7 @@
         var navigator = this.get_render_navigator();
         var action = navigator.get('forwards_navigation').item(0);
         action.addClass('inactive');
-        navigator.get_current_batch().next = {
+        navigator.get('current_batch').next = {
             start: 1, memo: 'pi'
         };
         navigator.render_navigation();
@@ -196,6 +193,16 @@
         Y.Assert.areEqual(
             '<strong>6</strong> \u2192 <strong>6</strong> of 256 results',
             index.getContent());
+    },
+    test_change_fields: function() {
+        // change_fields updates field visibility state and re-renders.
+        var navigator = this.get_render_navigator();
+        navigator.render();
+        Y.Assert.areEqual('bar', navigator.get('target').getContent());
+        Y.Assert.isTrue(navigator.get('field_visibility').show_foo);
+        navigator.change_fields({show_foo: false});
+        Y.Assert.isFalse(navigator.get('field_visibility').show_foo);
+        Y.Assert.areEqual('', navigator.get('target').getContent());
     }
 }));
 
@@ -217,9 +224,7 @@
                 bugtasks: []
             },
             next: null,
-            prev: null,
-            field_visibility: {},
-            field_visibility_defaults: {}
+            prev: null
         };
         var target = Y.Node.create('<div id="client-listing"></div>');
         var navigator = new module.ListingNavigator({
@@ -295,9 +300,7 @@
                 foo: 'bar'
             },
             next: null,
-            prev: null,
-            field_visibility: {},
-            field_visibility_defaults: {}
+            prev: null
         };
         var template = "<ol>" +
             "{{#item}}<li>{{name}}</li>{{/item}}</ol>";
@@ -454,9 +457,7 @@
             start: 400
         },
         order_by: 'foo',
-        last_start: 23,
-        field_visibility: {},
-        field_visibility_defaults: {}
+        last_start: 23
     };
     if (config.no_next){
         lp_cache.next = null;
@@ -564,7 +565,7 @@
     test_update_from_cache_generates_event: function(){
         var navigator = get_navigator('');
         var e = null;
-        navigator.get('model').get('history').on('change', function(inner_e){
+        navigator.get('history').on('change', function(inner_e){
             e = inner_e;
         });
         navigator.get('batches')['some-batch-key'] = {
@@ -595,9 +596,8 @@
         };
         navigator.set('template', '{{foo}}');
         navigator.get('batches')['some-batch-key'] = batch;
-        navigator.get('model').get('history').addValue(
-            'batch_key', 'some-batch-key');
-        Y.Assert.areEqual(batch, navigator.get_current_batch());
+        navigator.get('history').addValue('batch_key', 'some-batch-key');
+        Y.Assert.areEqual(batch, navigator.get('current_batch'));
         Y.Assert.areEqual('bar', navigator.get('target').getContent());
     }
 }));
@@ -666,9 +666,14 @@
 
     get_pre_fetch_navigator: function(config){
         var navigator = get_navigator('', config);
-        var batch = navigator.get_current_batch();
-        batch.next = {memo: 57, start: 56};
-        batch.order_by = '';
+        var lp_client = new Y.lp.client.Launchpad();
+        var batch = lp_client.wrap_resource(null, {
+            context: {
+                resource_type_link: 'http://foo_type',
+                web_link: 'http://foo/bar'
+            },
+            next: {memo: 57, start: 56}});
+        navigator.set('current_batch', batch);
         return navigator;
     },
 

=== modified file 'lib/lp/bugs/javascript/tests/test_buglisting_utils.html'
--- lib/lp/bugs/javascript/tests/test_buglisting_utils.html	2011-11-22 20:14:59 +0000
+++ lib/lp/bugs/javascript/tests/test_buglisting_utils.html	2011-11-28 20:51:15 +0000
@@ -14,24 +14,13 @@
 
  <!-- Dependencies from our tree -->
   <script type="text/javascript"
-          src="../../../app/javascript/lp.js"></script>
-  <script type="text/javascript"
           src="../../../app/javascript/configutils.js"></script>
   <script type="text/javascript"
           src="../../../app/javascript/formoverlay/formoverlay.js"></script>
   <link rel="stylesheet"
     href="../../../app/javascript/formoverlay/assets/formoverlay-core.css"/>
   <script type="text/javascript"
-          src="../../../app/javascript/client.js"></script>
-  <script type="text/javascript"
-          src="../../../app/javascript/effects/effects.js"></script>
-  <script type="text/javascript"
-          src="../../../app/javascript/errors.js"></script>
-  <script type="text/javascript"
-          src="../../../app/javascript/expander.js"></script>
-  <script type="text/javascript"
           src="../../../app/javascript/overlay/overlay.js"></script>
-  <script type="text/javascript" src="../buglisting.js"></script>
 
   <!-- The module under test -->
   <script type="text/javascript" src="../buglisting_utils.js"></script>

=== modified file 'lib/lp/bugs/javascript/tests/test_buglisting_utils.js'
--- lib/lp/bugs/javascript/tests/test_buglisting_utils.js	2011-11-24 15:10:45 +0000
+++ lib/lp/bugs/javascript/tests/test_buglisting_utils.js	2011-11-28 20:51:15 +0000
@@ -14,39 +14,17 @@
 
     name: 'buglisting_display_utils_tests',
 
+    _should: {
+        error: {
+
+            test_widget_requires_cache: [
+                'LP.cache.field_visibility must be defined ',
+                'when using BugListingConfigUtil.'
+            ].join('')
+        }
+    },
+
     setUp: function() {
-        // Default values for model config.
-        this.defaults = {
-            field_visibility: {
-                show_title: true,
-                show_id: false,
-                show_importance: false,
-                show_status: true,
-                show_bug_heat: true,
-                show_bugtarget: true,
-                show_age: false,
-                show_last_updated: false,
-                show_assignee: false,
-                show_reporter: false,
-                show_milestone_name: false,
-                show_tags: false
-            },
-
-            field_visibility_defaults: {
-                show_title: true,
-                show_id: true,
-                show_importance: true,
-                show_status: true,
-                show_bug_heat: true,
-                show_bugtarget: true,
-                show_age: false,
-                show_last_updated: false,
-                show_assignee: false,
-                show_reporter: false,
-                show_milestone_name: false,
-                show_tags: false
-            }
-        };
         // _setDoc is required for tests using cookies to pass.
         Y.Cookie._setDoc({cookie: ""});
         // Simulate LP.cache.field_visibility which will be
@@ -57,10 +35,39 @@
             },
 
             cache: {
+                field_visibility: {
+                    show_title: true,
+                    show_id: false,
+                    show_importance: false,
+                    show_status: true,
+                    show_bug_heat: true,
+                    show_bugtarget: true,
+                    show_age: false,
+                    show_last_updated: false,
+                    show_assignee: false,
+                    show_reporter: false,
+                    show_milestone_name: false,
+                    show_tags: false
+                },
+
+                field_visibility_defaults: {
+                    show_title: true,
+                    show_id: true,
+                    show_importance: true,
+                    show_status: true,
+                    show_bug_heat: true,
+                    show_bugtarget: true,
+                    show_age: false,
+                    show_last_updated: false,
+                    show_assignee: false,
+                    show_reporter: false,
+                    show_milestone_name: false,
+                    show_tags: false
+                },
+
                 cbl_cookie_name: 'foobar-buglist-fields'
             }
         };
-
         this.cookie_name = LP.cache.cbl_cookie_name;
     },
 
@@ -100,6 +107,23 @@
         Assert.isInstanceOf(Y.lp.configutils.BaseConfigUtil, this.list_util);
     },
 
+    test_default_field_visibility_config: function() {
+        // The default field_visibility must be supplied by LP.cache.
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
+        var defaults_from_cache = LP.cache.field_visibility_defaults;
+        var field_visibility_defaults = this.list_util.get(
+            'field_visibility_defaults');
+        ObjectAssert.areEqual(defaults_from_cache, field_visibility_defaults);
+    },
+
+    test_widget_requires_cache: function() {
+        // BugListingConfigUtil requires our JSON cache for
+        // field_visibility and will error on render if not found.
+        delete window.LP;
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
+        this.list_util.render();
+    },
+
     test_cookie_name_attribute: function() {
         // cookie_name is taken from the cache.
         this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
@@ -115,11 +139,39 @@
             foo: 'bar',
             baz: 'bop'
         };
-        this.list_util.get('model').set(
-            'field_visibility_defaults', attempted_defaults);
+        this.list_util.set('field_visibility_defaults', attempted_defaults);
         ObjectAssert.areEqual(
             this.list_util.get('field_visibility_defaults'),
-            this.defaults.field_visibility_defaults);
+            LP.cache.field_visibility_defaults);
+    },
+
+    test_supplied_field_visibility_config: function() {
+        // field_visibility can be changed at the call site.
+        // Supplied fields will be merged with the defaults.
+        var supplied_config = {
+            show_bug_heat: false,
+            show_status: false
+        };
+        var expected_config = {
+            show_title: true,
+            show_id: true,
+            show_importance: true,
+            show_status: false,
+            show_bug_heat: false,
+            show_bugtarget: true,
+            show_age: false,
+            show_last_updated: false,
+            show_assignee: false,
+            show_reporter: false,
+            show_milestone_name: false,
+            show_tags: false
+        };
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
+            field_visibility: supplied_config
+        });
+        this.list_util.render();
+        ObjectAssert.areEqual(
+            expected_config, this.list_util.get('field_visibility'));
     },
 
     test_cookie_updates_field_visibility_config: function() {
@@ -140,11 +192,9 @@
             show_tags: false
         };
         Y.Cookie.setSubs(this.cookie_name, expected_config);
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
-        var model = this.list_util.get('model');
-        var actual_config = model.get_field_visibility();
+        var actual_config = this.list_util.get('field_visibility');
         ObjectAssert.areEqual(expected_config, actual_config);
     },
 
@@ -155,11 +205,10 @@
         Assert.isNotUndefined(this.list_util.get('form'));
     },
 
-    test_field_visibility_form_shows_initial: function() {
-        // The form should have a checkbox for every field_visibility item,
+    test_field_visibility_form_shows_defaults: function() {
+        // The form should have a checkbox for every default item,
         // and the checked value should match true or false values.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         var expected_names = [
             'show_title',
@@ -177,8 +226,8 @@
         ];
         var expected_checked = [
             true,
-            false,
-            false,
+            true,
+            true,
             true,
             true,
             true,
@@ -197,14 +246,12 @@
     test_field_visibility_form_shows_supplied_defaults: function() {
         // The form checkboxes should also match the user supplied
         // config values.
-        var field_visibility = Y.merge(
-            this.defaults.field_visibility_defaults, {
+        var field_visibility = {
             show_status: false,
             show_bug_heat: false
-        });
+        };
         this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
-            field_visibility: field_visibility,
-            field_visibility_defaults: this.defaults.field_visibility_defaults
+            field_visibility: field_visibility
         });
         this.list_util.render();
         var expected_names = [
@@ -242,8 +289,7 @@
 
     test_click_icon_reveals_overlay: function() {
         // Clicking the settings icon should reveal the form overlay.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         var overlay = this.list_util.get('form').get('boundingBox');
         Assert.isTrue(overlay.hasClass('yui3-lazr-formoverlay-hidden'));
@@ -255,8 +301,7 @@
     test_field_visibility_form_update_config: function() {
         // Changing elements on the form also updates the field_visibility
         // config values.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         var config = Y.one('.config');
         config.simulate('click');
@@ -268,8 +313,8 @@
         update.simulate('click');
         var expected_config = {
             show_title: true,
-            show_id: false,
-            show_importance: false,
+            show_id: true,
+            show_importance: true,
             show_status: true,
             show_bug_heat: false,
             show_bugtarget: false,
@@ -280,15 +325,13 @@
             show_milestone_name: false,
             show_tags: false
         };
-        var model = this.list_util.get('model');
-        var actual_config = model.get_field_visibility();
+        var actual_config = this.list_util.get('field_visibility');
         ObjectAssert.areEqual(expected_config, actual_config);
     },
 
     test_form_update_hides_overlay: function() {
         // Updating the form overlay hides the overlay.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         var config = Y.one('.config');
         config.simulate('click');
@@ -300,11 +343,31 @@
         Assert.isTrue(overlay.hasClass('yui3-lazr-formoverlay-hidden'));
     },
 
+    test_update_config_fires_event: function() {
+        // A custom event fires when the field_visibility config
+        // is updated.
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
+        this.list_util.render();
+        // Setup event handler.
+        var event_fired = false;
+        Y.on('buglisting-config-util:fields-changed', function(e) {
+            event_fired = true;
+        });
+        // Poke at the page to update the form.
+        var config = Y.one('.config');
+        config.simulate('click');
+        var show_bugtarget = Y.one('.show_bugtarget');
+        show_bugtarget.simulate('click');
+        var update = Y.one('.update-buglisting');
+        update.simulate('click');
+        // Confirm the event handler worked.
+        Assert.isTrue(event_fired);
+    },
+
     test_update_from_form_updates_cookie: function() {
         // When the form is submitted, a cookie is set to match
         // your preferred field_visibility.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         // Now poke at the page to set the cookie.
         var config = Y.one('.config');
@@ -315,8 +378,8 @@
         update.simulate('click');
         var expected_config = {
             show_title: true,
-            show_id: false,
-            show_importance: false,
+            show_id: true,
+            show_importance: true,
             show_status: true,
             show_bug_heat: true,
             show_bugtarget: false,
@@ -341,18 +404,23 @@
             show_bug_heat: false
         };
         this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
-            field_visibility: field_visibility,
-            field_visibility_defaults: this.defaults.field_visibility_defaults
+            field_visibility: field_visibility
         });
         this.list_util.render();
+        // Setup event handler.
+        var event_fired = false;
+        Y.on('buglisting-config-util:fields-changed', function(e) {
+            event_fired = true;
+            // Confirm that field_visibility is now the same as the defaults.
+            var defaults = this.list_util.field_visibility_defaults;
+            var fields = this.list_util.get('field_visibility');
+            ObjectAssert.areEqual(defaults, fields);
+        }, this);
         // Poke at the page to reset the form.
         var config = Y.one('.config');
         config.simulate('click');
         Y.one('.reset-buglisting').simulate('click');
-        var model = this.list_util.get('model');
-        var defaults = model.get('field_visibility_defaults');
-        var fields = model.get_field_visibility();
-        ObjectAssert.areEqual(defaults, fields);
+        Assert.isTrue(event_fired);
     },
 
     test_fields_visibility_form_reset_hides_overlay: function() {
@@ -362,8 +430,7 @@
             show_bug_heat: false
         };
         this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
-            field_visibility: field_visibility,
-            field_visibility_defaults: this.defaults.field_visibility_defaults
+            field_visibility: field_visibility
         });
         this.list_util.render();
         // Poke at the form to reset defaults.
@@ -376,14 +443,12 @@
 
     test_fields_visibility_form_reset_updates_form: function() {
         // Reseting to defaults should reset the form inputs, too.
-        var field_visibility = Y.merge(
-            this.defaults.field_visibility_defaults, {
+        var field_visibility = {
             show_bugtarget: false,
             show_bug_heat: false
-        });
+        };
         this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
-            field_visibility: field_visibility,
-            field_visibility_defaults: this.defaults.field_visibility_defaults
+            field_visibility: field_visibility
         });
         this.list_util.render();
         var expected_names = [
@@ -426,8 +491,7 @@
     test_form_reset_removes_cookie: function() {
         // Clicking "reset to defaults" on the overlay will
         // remove any cookie added.
-        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil(
-            this.defaults);
+        this.list_util = new Y.lp.buglisting_utils.BugListingConfigUtil();
         this.list_util.render();
         // Now poke at the page to set the cookie.
         var config = Y.one('.config');

=== modified file 'lib/lp/bugs/templates/buglisting-default.pt'
--- lib/lp/bugs/templates/buglisting-default.pt	2011-11-28 14:28:09 +0000
+++ lib/lp/bugs/templates/buglisting-default.pt	2011-11-28 20:51:15 +0000
@@ -53,10 +53,12 @@
             });
             var config_node = orderby.get('config_node');
             var list_util = new Y.lp.buglisting_utils.BugListingConfigUtil({
-                srcNode: config_node,
-                model: navigator.get('model')
+                srcNode: config_node
             });
             list_util.render();
+            Y.on('buglisting-config-util:fields-changed', function(e) {
+                navigator.change_fields(list_util.get('field_visibility'));
+            });
         });
     });
   </script>

